%compute LSQMI cv

%split test and training.

Z = W*X;
[Cz, ZC_diff, ZC_dist, CzCz_dist] = Z_gen(Z,cindz);
    
Hhat = ((sqrt(pi)*sigma)^(dz+dy))*exp(-(CzCz_dist+CyCy_dist)/(4*sigma^2));

GauZ2D = exp(-ZC_dist/(2*sigma^2));
GauY2D = exp(-YC_dist/(2*sigma^2)); %[b n]

QMI_A = 0;
for ii = 1 : FOLDNUM

	hz_train = GauZ2D(:,cv_index(cv_split~=ii));
	hy_train = GauY2D(:,cv_index(cv_split~=ii));
	h_train = mean(hz_train.*hy_train, 2) - mean(hz_train, 2).*mean(hy_train,2);
	
	hz_test = GauZ2D(:,cv_index(cv_split==ii));
	hy_test = GauY2D(:,cv_index(cv_split==ii));
	h_test = mean(hz_test.*hy_test, 2) - mean(hz_test, 2).*mean(hy_test,2);
	
	theta = mylinsolve(Hhat + lambda*Ib, h_train);

	QMI_A = QMI_A + (theta'*h_test - theta'*Hhat*theta/2);	%QMI value (positive)

end

QMI_A = QMI_A/FOLDNUM;

